%------------Universidade Federal do Recncavo da Bahia--------------
%-------------Universidade Federal de So Joo del-Rei---------------------
%---------------Grupo de Controle e Modelagem------------------------------
%Rotina: LARSim_MKP
%Autores: Andr Luiz Carvalho Ottoni (UFRB) - andreottoni@ymail.com
%         Erivelton Geraldo Nepomuceno (UFSJ)
%         Marcos Santos de Oliveira (UFSJ)
%Data de criao: 28/08/2018  
%Descrio: Cdigo da interface grfica LARSim_MKP

function varargout = LARSim_MKP(varargin)
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @LARSim_MKP_OpeningFcn, ...
                   'gui_OutputFcn',  @LARSim_MKP_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

% --- Executes just before LARSim_MKP is made visible.
function LARSim_MKP_OpeningFcn(hObject, eventdata, handles, varargin)
handles.output = hObject;
guidata(hObject, handles);


% --- Outputs from this function are returned to the command line.
function varargout = LARSim_MKP_OutputFcn(hObject, eventdata, handles) 
varargout{1} = handles.output;


% --- Executes on button press in executar.
function executar_Callback(hObject, eventdata, handles)
    q = get(handles.qlearning,'Value');
    s = get(handles.sarsa,'Value');
    num = get(handles.episodios,'String');
    alpha = get(handles.alpha,'String');
    gamma = get(handles.fator,'String');
    e = get(handles.egreedy,'String');
    inst = get(handles.instancia,'Value');
    handles.inst = inst;
    conv = get(handles.conv,'Value');
    log = get(handles.log,'Value');
    
    a = str2num(alpha);
    b= str2num(gamma);
    c = str2num(e);
    d = str2num(num);
    handles.num = d;
    
    if q > 0
        alg = 1;
    else
        alg = 2;
    end

   [maximo,media,soma,episodio,otimo,x,n,m,nome,v]= MKPSimuladorMKP(a,b,c,alg,d,inst);
    handles.soma = soma;
    itens = x(episodio(1),:);
    handles.itens = itens;
    handles.nome = nome;
    handles.export = [otimo; maximo; media; episodio(1); n; m];
    handles.v = v;
    
    set(handles.otimo,'String',otimo);
    set(handles.maximo,'String',maximo);
    set(handles.media,'String',media);
    set(handles.episodio,'String',episodio(1));
    set(handles.n,'String',n);
    set(handles.m,'String',m);
    set(handles.res1,'String',soma(1));
    set(handles.res10,'String',soma(10));
    set(handles.res100,'String',soma(100));
    set(handles.resfim,'String',soma(d));
    
    axes(handles.graf1);
    if conv==1
        plot(soma, '-');
    else
       semilogx(soma, '-');
    end
    ylabel('Soma');
    xlabel('Episdios');
    guidata(hObject, handles); 
    
    axes(handles.graf2);
    plot(itens, 'o');
    ylabel('0 - No / 1 - Sim');
    xlabel('Itens');
    ylim([-0.2 1.2]);
    guidata(hObject, handles); 
    
    axes(handles.graf3);
    plot(x(1,:), 'o');
    ylabel('0 - No / 1 - Sim');
    xlabel('Itens');
    ylim([-0.2 1.2]);
    guidata(hObject, handles); 
    
    
    axes(handles.graf4);
     plot(x(10,:), 'o');
    ylabel('0 - No / 1 - Sim');
    xlabel('Itens');
    ylim([-0.2 1.2]);
    guidata(hObject, handles); 
    
    axes(handles.graf5);
    plot(x(100,:), 'o');
    ylabel('0 - No / 1 - Sim');
    xlabel('Itens');
    ylim([-0.2 1.2]);
    guidata(hObject, handles); 
    
    axes(handles.graf6);
    plot(x(d,:), 'o');
    ylabel('0 - No / 1 - Sim');
    xlabel('Itens');
    ylim([-0.2 1.2]);
    guidata(hObject, handles); 
   

function episodios_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function episodios_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in graficos.
function graficos_Callback(hObject, eventdata, handles)
    figure(1)
    plot(handles.soma, '-');
    ylabel('Soma');
    xlabel('Episdios');
       
    figure(2)
    semilogx(handles.soma, '-');
    ylabel('Soma');
    xlabel('Episdios');
   
    figure(3)
    plot(handles.itens, 'o');
    title('Itens Selecionados');
    ylabel('0 - No / 1 - Sim');
    xlabel('Itens');
    ylim([-0.2 1.2]);

function alpha_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function alpha_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function fator_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function fator_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function egreedy_Callback(hObject, eventdata, handles)


% --- Executes during object creation, after setting all properties.
function egreedy_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in instancia.
function instancia_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function instancia_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function otimo_Callback(hObject, eventdata, handles)


% --- Executes during object creation, after setting all properties.
function otimo_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function maximo_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function maximo_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function episodio_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function episodio_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function media_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function media_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function m_Callback(hObject, eventdata, handles)


% --- Executes during object creation, after setting all properties.
function m_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function n_Callback(hObject, eventdata, handles)
% hObject    handle to n (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of n as text
%        str2double(get(hObject,'String')) returns contents of n as a double


% --- Executes during object creation, after setting all properties.
function n_CreateFcn(hObject, eventdata, handles)
% hObject    handle to n (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function res1_Callback(hObject, eventdata, handles)


% --- Executes during object creation, after setting all properties.
function res1_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function res10_Callback(hObject, eventdata, handles)


% --- Executes during object creation, after setting all properties.
function res10_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function res100_Callback(hObject, eventdata, handles)


% --- Executes during object creation, after setting all properties.
function res100_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function resfim_Callback(hObject, eventdata, handles)



% --- Executes during object creation, after setting all properties.
function resfim_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in exportar.
function exportar_Callback(hObject, eventdata, handles)
    %titulo_itens = sprintf('resultados/itens_%2s',handles.nome);
    %titulo_soma = sprintf('resultados/soma_%2s',handles.nome);
    %xlswrite(titulo_itens, handles.itens');
    %xlswrite(titulo_soma, handles.soma');
    
    i = 1:handles.export(5);
    itens = [i; handles.itens; handles.v];  
    
    j = 1:1:handles.num;
    res = [j; handles.soma];
    
    dt = datestr(now,'dd/mm/yyyy HH:MM:SS');
 
    titulo = sprintf('resultados/LARSim_MKP_%2s.txt',handles.nome);
    fileID = fopen(titulo,'w');

    fprintf(fileID,'%12s\n','----------------------LARSim MKP---------------------------');
    fprintf(fileID,'%4s %4s\n','Data:',dt);
    fprintf(fileID,'%6s %4s\n','Instncia:',handles.nome);
    fprintf(fileID,'%6s %8f\n','timo:',handles.export(1));
    fprintf(fileID,'%6s %2d\n','Mochilas (m):',handles.export(6));
    fprintf(fileID,'%6s %2d\n','Itens (n):',handles.export(5));
    fprintf(fileID,'%12s\n','------------------------');
    fprintf(fileID,'%6s \n','Resultados:');
    fprintf(fileID,'%6s %8f\n','Mximo:',handles.export(2));
    fprintf(fileID,'%6s %2d\n','Episdio:',handles.export(4));
    fprintf(fileID,'%6s %8f\n','Mdia:',handles.export(3));
    fprintf(fileID,'%12s\n','------------------------');
    fprintf(fileID,'%12s \n','Itens Selecionados :');
    fprintf(fileID,'%6s %12s %8s\n','Item','(1 - Sim / 0 - No)','Valor');
    fprintf(fileID,'%6d %12d %16f\n',itens);
    fprintf(fileID,'%12s\n','------------------------');
    fprintf(fileID,'%12s \n','Resultados da soma por episdio :');
    fprintf(fileID,'%6s %6s\n','Episdio','Soma');
    fprintf(fileID,'%6d %12f\n',res);
    fclose(fileID);


    
