% Rotina LARSim_Nav para executar o LARSim Nav
%------------Universidade Federal do Recncavo da Bahia--------------
%-------------Universidade Federal de So Joo del-Rei---------------------
%---------------Grupo de Controle e Modelagem------------------------------
%Rotina: LARSim_Nav
%Autores: Andr Luiz Carvalho Ottoni (UFRB) - andreottoni@ymail.com
%         Erivelton Geraldo Nepomuceno (UFSJ)
%         Marcos Santos de Oliveira (UFSJ)
%Data de criao: 28/08/2018   
%Descrio: Executa o simulador do labirinto - Interface grfica

function varargout = LARSim_Nav(varargin)
    gui_Singleton = 1;
    gui_State = struct('gui_Name',       mfilename, ...
        'gui_Singleton',  gui_Singleton, ...
        'gui_OpeningFcn', @LARSim_Nav_OpeningFcn, ...
        'gui_OutputFcn',  @LARSim_Nav_OutputFcn, ...
        'gui_LayoutFcn',  [] , ...
        'gui_Callback',   []);
    if nargin && ischar(varargin{1})
        gui_State.gui_Callback = str2func(varargin{1});
    end
    if nargout
        [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
    else
        gui_mainfcn(gui_State, varargin{:});
    end

% --- Executes just before LARSim_Nav is made visible.
function LARSim_Nav_OpeningFcn(hObject, eventdata, handles, varargin)
    handles.output = hObject;
    guidata(hObject, handles);
    %set(handles.navegacao,'SelectionChangeFcn',@navegacao_SelectionChangeFcn);
    
% --- Outputs from this function are returned to the command line.
function varargout = LARSim_Nav_OutputFcn(hObject, eventdata, handles)
    varargout{1} = handles.output;

% --- Executes on button press in executar.
function executar_Callback(hObject, eventdata, handles)
    reat = get(handles.reativa,'Value');
    delib = get(handles.deliberativa,'Value');
    q = get(handles.qlearning,'Value');
    s = get(handles.sarsa,'Value');
    m1 = get(handles.mapa1,'Value');
    m2 = get(handles.mapa2,'Value');
    m3 = get(handles.mapa3,'Value');
    conv = get(handles.conv,'Value');
    log = get(handles.log,'Value');
    
    if reat > 0
        nav = 1;
        handles.nomnav = 'Reativa';
    else
        nav = 2;
        handles.nomnav = 'Deliberativa';
    end
    if q > 0
        alg = 1;
    else
        alg = 2;
    end
    if m1 > 0
        mapa = 1;
    else
        if m2 > 0
           mapa = 2;
        else
           mapa = 3;
        end
    end
    alpha = get(handles.taxa,'String');
    gamma = get(handles.fator,'String');
    e = get(handles.egreedy,'String');
    a = str2num(alpha);
    b= str2num(gamma);
    c = str2num(e);
    [caminhox,caminhoy,passos,resultado,episodio,chegou]= NavSimuladorLabirinto(nav,a,b,c,alg,mapa);
    handles.caminhox = caminhox;
    handles.caminhoy = caminhoy;
    handles.passos = passos;
    handles.resultado = resultado;
    handles.episodio = episodio;
    sucessos = sum(resultado);
    handles.mapa = mapa;
    
    handles.export = [sucessos; passos(1); passos(chegou); max(passos); min(passos); mean(passos)];
    
    
    axes(handles.graf1);
    if conv==1
         plot(passos, '-');
    else
        semilogx(passos, '-');
    end
   
    %title('Quantidade de passos necessrios para chegar ao objetivo');
    ylabel('Nmero de passos');
    xlabel('Sucessos');
    guidata(hObject, handles); 
    
    resultado = resultado';
    acumulado(3) = 0;
    for i = 2:episodio
       acumulado(i) = acumulado(i-1)+resultado(i);
    end
    axes(handles.graf2);
    plot(acumulado, '-o');
    ylabel('Sucessos Acumulados');
    xlabel('Episdios');
    
   
    set(handles.res1,'String',sucessos);
    set(handles.res2,'String',passos(1));
    set(handles.res3,'String',passos(chegou));
    set(handles.res4,'String',max(passos));
    set(handles.res5,'String',min(passos));
    set(handles.res6,'String',mean(passos));
    
    

% --- Executes on button press in logplayer.
function logplayer_Callback(hObject, eventdata, handles)
    figure(4);
    NavLogPlayer(handles.caminhox, handles.caminhoy, handles.mapa);

% --- Executes on button press in graficos.
function graficos_Callback(hObject, eventdata, handles)
    NavPlotFiguras(handles.passos, handles.episodio, handles.resultado);


function taxa_Callback(hObject, eventdata, handles)
input = str2num(get(hObject,'String'));
if (isempty(input))
    set(hObject,'String','0')
end

% --- Executes during object creation, after setting all properties.
function taxa_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function fator_Callback(hObject, eventdata, handles)
input = str2num(get(hObject,'String'));
if (isempty(input))
    set(hObject,'String','0')
end


% --- Executes during object creation, after setting all properties.
function fator_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function egreedy_Callback(hObject, eventdata, handles)


% --- Executes during object creation, after setting all properties.
function egreedy_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function res1_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function res1_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function res2_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function res2_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function res3_Callback(hObject, eventdata, handles)


% --- Executes during object creation, after setting all properties.
function res3_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function res4_Callback(hObject, eventdata, handles)


% --- Executes during object creation, after setting all properties.
function res4_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function res5_Callback(hObject, eventdata, handles)
% --- Executes during object creation, after setting all properties.
function res5_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function res6_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function res6_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in exportar.
function exportar_Callback(hObject, eventdata, handles)
    j = 1:1:handles.export(1);
    handles.export;
    res = [j; handles.passos];
   
    dt = datestr(now,'dd/mm/yyyy HH:MM:SS');
    
    titulo = sprintf('resultados/LARSim_Nav_mapa%d.txt',handles.mapa);
    fileID = fopen(titulo,'w');
     
    fprintf(fileID,'%12s\n','----------------------LARSim Nav---------------------------');
    fprintf(fileID,'%4s %4s\n','Data:',dt);
    fprintf(fileID,'%4s %2d\n','Mapa:',handles.mapa);
    fprintf(fileID,'%6s %7s\n','Navegao:',handles.nomnav);
    fprintf(fileID,'%12s\n','------------------------');
    fprintf(fileID,'%6s \n','Resultados:');
    fprintf(fileID,'%6s %2d\n','Sucessos:',handles.export(1));
    fprintf(fileID,'%6s %2d\n','Nmero de passos para o primeiro sucesso:',handles.export(2));
    fprintf(fileID,'%6s %2d\n','Nmero de passos para o ltimo sucesso:',handles.export(3));
    fprintf(fileID,'%6s %2d\n','Nmero mximo de passos:',handles.export(4));
    fprintf(fileID,'%6s %2d\n','Nmero mnimo de passos:',handles.export(5));
    fprintf(fileID,'%6s %2f\n','Mdia de passos:',handles.export(6));
    fprintf(fileID,'%12s\n','------------------------');
    fprintf(fileID,'%12s \n','Resultados da distncia calculada por sucesso:');
    fprintf(fileID,'%6s %10s\n','Sucesso','Distncia');
    fprintf(fileID,'%6d %10d\n',res);
    fclose(fileID);
