%------------Universidade Federal do Recncavo da Bahia--------------
%-------------Universidade Federal de So Joo del-Rei---------------------
%---------------Grupo de Controle e Modelagem------------------------------
%Rotina: LARSim_TSP 
%Autores: Andr Luiz Carvalho Ottoni (UFRB) - andreottoni@ymail.com
%         Erivelton Geraldo Nepomuceno (UFSJ)
%         Marcos Santos de Oliveira (UFSJ)
%Data de criao: 28/08/2018  
%Descrio: Cdigo da interface grfica LARSim_TSP

function varargout = LARSim_TSP(varargin)
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @LARSim_TSP_OpeningFcn, ...
                   'gui_OutputFcn',  @LARSim_TSP_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

% --- Executes just before LARSim_TSP is made visible.
function LARSim_TSP_OpeningFcn(hObject, eventdata, handles, varargin)
handles.output = hObject;
guidata(hObject, handles);
   

% --- Outputs from this function are returned to the command line.
function varargout = LARSim_TSP_OutputFcn(hObject, eventdata, handles) 
varargout{1} = handles.output;

% --- Executes on button press in executar.
function executar_Callback(hObject, eventdata, handles)
    q = get(handles.qlearning,'Value');
    s = get(handles.sarsa,'Value');
    num = get(handles.num_episodios,'String');
    alpha = get(handles.taxa,'String');
    gamma = get(handles.fator,'String');
    e = get(handles.egreedy,'String');
    inst = get(handles.instancia,'Value');
    conv = get(handles.conv,'Value');
    log = get(handles.log,'Value');
    
    a = str2num(alpha);
    b= str2num(gamma);
    c = str2num(e);
    d = str2num(num);
    handles.num = d;
    
    if q > 0
        alg = 1;
    else
        alg = 2;
    end
    
    [menor,distancia,episodio,visita,N,posicao,otimo,nome]= TSPSimuladorPCV(a,b,c,alg,d,inst);
    handles.distancia = distancia;
    handles.N = N;
    handles.episodio = episodio;
    handles.visita = visita;
    handles.posicao = posicao;
    handles.nome = nome;
    handles.export = [otimo; menor; episodio(1); mean(distancia)];
    
    set(handles.otimo,'String',otimo);
    set(handles.resmenor,'String',menor);
    set(handles.med,'String',mean(distancia));
    set(handles.epis,'String',episodio(1));
    set(handles.res10,'String',distancia(10));
    set(handles.res50,'String',distancia(50));
    set(handles.res100,'String',distancia(100));
    set(handles.res1000,'String',distancia(handles.num));
    
    axes(handles.grafico1);
    if conv==1
       plot(distancia, '-');
    else
       semilogx(distancia, '-');
    end
    ylabel('Distncia');
    xlabel('Episdios');
    guidata(hObject, handles); 
    
    axes(handles.grafico2);
    TSPdesenharrota(episodio(1),visita,N,posicao);
    guidata(hObject, handles); 
    
    axes(handles.grafico3);
    TSPdesenharrota(10,visita,N,posicao);
    %title('Episdio 10');
    guidata(hObject, handles); 
    
    axes(handles.grafico4);
    TSPdesenharrota(50,visita,N,posicao);
    %title('Episdio 50');
    guidata(hObject, handles); 
    
    axes(handles.grafico5);
    TSPdesenharrota(100,visita,N,posicao);
    %title('Episdio 100');
    guidata(hObject, handles); 
    
    axes(handles.grafico6);
    TSPdesenharrota(handles.num,visita,N,posicao);
    %title('ltimo Episdio');
    guidata(hObject, handles); 
    
function graficos_Callback(hObject, eventdata, handles)    
    
    figure(1);
    plot(handles.distancia, '-');
    ylabel('Distncia');
    xlabel('Episdios');
    
    figure(2);
    semilogx(handles.distancia, '-');
    ylabel('Distncia');
    xlabel('Episdios');
   
    figure(3);
    TSPdesenharrota(handles.episodio(1),handles.visita,handles.N,handles.posicao);
    title('Menor Rota');
    
    figure(4);
    TSPdesenharrota(10,handles.visita,handles.N,handles.posicao);
    title('Episdio 10');
 
    figure(5);
    TSPdesenharrota(50,handles.visita,handles.N,handles.posicao);
    title('Episdio 50');
    
    figure(6);
    TSPdesenharrota(100,handles.visita,handles.N,handles.posicao);
    title('Episdio 100');
    
    figure(7);
    TSPdesenharrota(handles.num,handles.visita,handles.N,handles.posicao);
    title('ltimo Episdio');
    
function taxa_Callback(hObject, eventdata, handles)

function taxa_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function fator_Callback(hObject, eventdata, handles)

function fator_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function egreedy_Callback(hObject, eventdata, handles)

function egreedy_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function radiobutton1_Callback(hObject, eventdata, handles)

function sarsa_Callback(hObject, eventdata, handles)



function res10_Callback(hObject, eventdata, handles)

% --- Executes during object creation, after setting all properties.
function res10_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function res50_Callback(hObject, eventdata, handles)


% --- Executes during object creation, after setting all properties.
function res50_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function res100_Callback(hObject, eventdata, handles)


% --- Executes during object creation, after setting all properties.
function res100_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function res1000_Callback(hObject, eventdata, handles)


% --- Executes during object creation, after setting all properties.
function res1000_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function resmenor_Callback(hObject, eventdata, handles)

function resmenor_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function num_episodios_Callback(hObject, eventdata, handles)

function num_episodios_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function epis_Callback(hObject, eventdata, handles)


% --- Executes during object creation, after setting all properties.
function epis_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function med_Callback(hObject, eventdata, handles)
% hObject    handle to med (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of med as text
%        str2double(get(hObject,'String')) returns contents of med as a double


% --- Executes during object creation, after setting all properties.
function med_CreateFcn(hObject, eventdata, handles)
% hObject    handle to med (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in instancia.
function instancia_Callback(hObject, eventdata, handles)
% hObject    handle to instancia (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns instancia contents as cell array
%        contents{get(hObject,'Value')} returns selected item from instancia


% --- Executes during object creation, after setting all properties.
function instancia_CreateFcn(hObject, eventdata, handles)
% hObject    handle to instancia (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function otimo_Callback(hObject, eventdata, handles)
% hObject    handle to otimo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of otimo as text
%        str2double(get(hObject,'String')) returns contents of otimo as a double


% --- Executes during object creation, after setting all properties.
function otimo_CreateFcn(hObject, eventdata, handles)
% hObject    handle to otimo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit13_Callback(hObject, eventdata, handles)
% hObject    handle to edit13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit13 as text
%        str2double(get(hObject,'String')) returns contents of edit13 as a double


% --- Executes during object creation, after setting all properties.
function edit13_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --------------------------------------------------------------------
function Sobre_Callback(hObject, eventdata, handles)


% --------------------------------------------------------------------
function Artigo_Callback(hObject, eventdata, handles)
   open('pdfs/Ottoni2018.pdf');


% --- Executes on button press in exportar.
function exportar_Callback(hObject, eventdata, handles)
    %i = 1:handles.export(5);
    %itens = [i; handles.itens; handles.v];  
    
    j = 1:1:handles.num;
    res = [j; handles.distancia];
 
    a = handles.visita(handles.episodio(1),:,1);
    b = handles.visita(handles.episodio(1),:,2);
    vis = [a; b];

    dt = datestr(now,'dd/mm/yyyy HH:MM:SS');
    titulo = sprintf('resultados/LARSim_TSP_%2s.txt',handles.nome);
    fileID = fopen(titulo,'w');
     
    fprintf(fileID,'%12s\n','----------------------LARSim TSP---------------------------');
    fprintf(fileID,'%4s %4s\n','Data:',dt);
    fprintf(fileID,'%6s %4s\n','Instncia:',handles.nome);
    fprintf(fileID,'%6s %8f\n','timo:',handles.export(1));
    fprintf(fileID,'%6s %2d\n','Nmero de localidades (N):',handles.N);
    fprintf(fileID,'%12s\n','------------------------');
    fprintf(fileID,'%6s \n','Resultados:');
    fprintf(fileID,'%6s %8f\n','Mnimo:',handles.export(2));
    fprintf(fileID,'%6s %2d\n','Episdio:',handles.export(3));
    fprintf(fileID,'%6s %8f\n','Mdia:',handles.export(4));
    fprintf(fileID,'%12s\n','------------------------');
    fprintf(fileID,'%12s \n','Caminho definido :');
    fprintf(fileID,'%2d -> %2d\n',vis);
    fprintf(fileID,'%12s\n','------------------------');
    fprintf(fileID,'%12s \n','Resultados da distncia calculada por episdio :');
    fprintf(fileID,'%6s %6s\n','Episdio','Distncia');
    fprintf(fileID,'%6d %12f\n',res);
    fclose(fileID);
