%------------Universidade Federal do Recncavo da Bahia--------------
%-------------Universidade Federal de So Joo del-Rei---------------------
%---------------Grupo de Controle e Modelagem------------------------------
%Funo: MKPSimuladorMKP() 
%Autores: Andr Luiz Carvalho Ottoni (UFRB) - andreottoni@ymail.com
%         Erivelton Geraldo Nepomuceno (UFSJ)
%         Marcos Santos de Oliveira (UFSJ)
%Data de criao: 28/08/2018 
%Descrio: Rotina principal do LARSim MKP

function [maximo,media,soma,episodio,otimo,x,n,m,nome,v]= MKPSimuladorMKP(alpha,gamma,e,alg,epis,inst)

    switch inst
        case 1
            [n,m,v,c,p,otimo,nome]=MKPhp1();
        case 2
            [n,m,v,c,p,otimo,nome]=MKPhp2();
        case 3
            [n,m,v,c,p,otimo,nome]=MKPpb1();
        case 4
            [n,m,v,c,p,otimo,nome]=MKPpb2();
        case 5
            [n,m,v,c,p,otimo,nome]=MKPsento1();
        case 6
            [n,m,v,c,p,otimo,nome]=MKPweing1();
        case 7
            [n,m,v,c,p,otimo,nome]=MKPweing2();
        case 8
            [n,m,v,c,p,otimo,nome]=MKPweing3();
        case 9
            [n,m,v,c,p,otimo,nome]=MKPweing4();
        case 10
            [n,m,v,c,p,otimo,nome]=MKPweing5();
        case 11
            [n,m,v,c,p,otimo,nome]=MKPweing6();
        case 12
            [n,m,v,c,p,otimo,nome]=MKPweing7();
        case 13
            [n,m,v,c,p,otimo,nome]=MKPweish1();
        case 14
            [n,m,v,c,p,otimo,nome]=MKPweish2();
        case 15
            [n,m,v,c,p,otimo,nome]=MKPweish3();
        case 16
            [n,m,v,c,p,otimo,nome]=MKPweish30();
    end
    %-----------------------------------------------------------------------


    soma = zeros(1,epis); %armazena o resultado da funo objetivo
    x = zeros(epis,n);  %vetor de itens escolhidos (1-SIM, 0-No)
    cap = zeros(epis,m); %capacidade utilizada em cada mochila por iterao

    %--------------Variveis de Aprendizado por Reforo

    Q=zeros(n); % Matriz de Aprendizado Q
    %Matriz de Recompensa R
    %A recompensa  o valor do item menos os pesos para cada mochila
    R = v;
    for i=1:m
        R = R -p(i,:);
    end


    %----------------------------------------------------

    %Loop de episdios do Aprendizado por Reforo
    for k=1:epis

        %selecione o estado inicial e ao inicial aleatoriamente em cada episdio
        itemon = 0;
        S = round(1 + (n-1).*rand(1));
        while itemon==0
            item = round(1 + (n-1).*rand(1));
            if S>item || S<item
                itemon = 1;
            end
        end
        A = item;
        %-------------------------

        bag=1:n; %informa quais itens j foram escolhidas
        visita(k,1,:)=S; %armazena as visitas em cada estado
        capok = zeros(1,m); % armazena se ao colocar um item est dentro da capacidade da mochila

        %Loop de iteraes: varia de acordo o nmero de itens
        for j=1:n
            bag(A)=0; %a cada ao, o item  retirado da lisra de bag
            [resto]=find(bag~=0); %resto armazena os itens que ainda no foram retirados da lista
            if isempty(resto)
                j = n;
            else      % se a lista no est vazia, executa o procedimento de colocar mais itens
                for i=1:m % verifica as restries de capacidade para cada mochila
                    if (cap(k,i)+p(i,A))<c(i)
                        capok(i)=1;     % capacidade para mochila ok
                    end
                end

                if sum(capok)==m   % se a capacidade est ok para todas as mochilas
                    for i=1:m
                        cap(k,i) = cap(k,i) + p(i,A); % ento adiciona para todas as mochilas o peso do item selecionado
                    end
                    soma(k) = soma(k)+v(A); % acrescenta na soma (funo objetivo)
                    x(k,A)=1;  % armazena o item escolhido
                     if alg == 1
                        [SS,AA,Q]=Qlearning(S,A,R(A),Q,alpha,e,gamma,resto); %function [SS,AA,Q]=Q_Learning(S,A,R,Q)
                     else
                        [SS,AA,Q]=SARSA(S,A,R(A),Q,alpha,e,gamma,resto); %function [SS,AA,Q]=Q_Learning(S,A,R,Q)
                     end
                    %[SS,AA,Q]=Q_Learning(S,A,R(A),Q,alpha,e,gamma,resto); % funo de AR
                    visita(k,j+1,:)=A;  %armazena a visita a Ao
                    S=SS; A=AA;  %atualiza o estado e ao para a prxima iterao
                end

                capok = zeros(1,m);  % zera a varivel que verifica a capacidade para utilizar na prxima iterao
            end
        end
    end

    media = mean(soma); %mdia da resposta em uma poca para o documento geral
    maximo = max(soma); %mximo encontro da resposta em uma poca para o documento geral
    episodio = find(soma==max(soma));  %Episdio com a menor rota
end


