function [Posy, Posx, episodio, result] = NavExecutaAcao(a, Posy, Posx, episodio, Posinicialy, Posinicialx, M)
% function [Posy, Posx, episodio, result] = NavExecutaAcao(a, Posy, Posx, episodio, Posinicialy, Posinicialx, M)
%
% Entradas
%	a 	    - ao no instante t
%	Posy	- posio do agente em y no instante t
%	Posx	- posio do agente em x no instante t
%   eposiodio - nmero do episdio no instante t
%   Posinicialy - posio inicial padro do agente no eixo y
%   Posinicialx - posio inicial padro do agente no eixo x
%   M - matriz de mapeameanto
%
% Sadas
%	Posy	- posio do agente em y no instante t+1
%	Posx	- posio do agente em x no instante t+1
%   eposiodio - nmero do episdio no instante t+1
%   result - resultado do episdio    
%            - 1: nada aconteceu, no  gravado no resultado(episodio) /caminho livre
%             0: bateu no obstculo
%             1: chegou no objetivo
%------------Universidade Federal do Recncavo da Bahia--------------
%-------------Universidade Federal de So Joo del-Rei---------------------
%---------------Grupo de Controle e Modelagem------------------------------
%Funo: ExecutaAcao()
%Autores: Andr Luiz Carvalho Ottoni (UFRB) - andreottoni@ymail.com
%         Erivelton Geraldo Nepomuceno (UFSJ)
%         Marcos Santos de Oliveira (UFSJ)
%Data de criao: 11/07/2016      
%Descrio: Executa a ao

%Mais informaes: http://www.ufsj.edu.br/gcom

  result = -1; %Inicializa a varivel result
  %Resultado para o Episdio
      % - 1: nada aconteceu, no  gravado no resultado(episodio) /caminho livre
      % 0: bateu no obstculo
      % 1: chegou no objetivo
   
  %Execuo das aes
      % a = 1: Ir pro Norte 
      % a = 2: Ir pro Oeste
      % a = 3: Ir pro Leste
  % Ao executar a ao muda a Posio do agente, alterando sua posio em Y
  % (PosY) se for pro Norte, ou em X (PosX) se for Leste ou Leste.
  % Caso a nova posio do mapa for o obstculo M(Posy, Posx)==1, ento o
  % agente volta para a posio inicial e o resultado para o episdio  de
  % fracasso, resultado(episodio) = 0;
       
  %Ir pro Norte 
  if a==1
      Posy = Posy-1;
      if(M(Posy, Posx)==1)
          episodio = episodio+1;
          Posy = Posinicialy;
          Posx = Posinicialx;
          result = 0;
      end   
  end
  
  %Ir pro Oeste
  if a==2
      Posx = Posx-1;
      if(M(Posy, Posx)==1)
          episodio = episodio+1;
          Posy = Posinicialy;
          Posx = Posinicialx;
          result = 0;
      end 
  end
  
  %Ir Pro Leste
  if a==3
      Posx = Posx+1;
      if(M(Posy, Posx)==1)
          episodio = episodio+1;
          Posy = Posinicialy;
          Posx = Posinicialx;
          result = 0;
      end
  end
   
end