function NavLogPlayer(caminhox, caminhoy, mapa)
   %------------Universidade Federal do Recncavo da Bahia--------------
   %-------------Universidade Federal de So Joo del-Rei---------------------
   %---------------Grupo de Controle e Modelagem------------------------------
   %Rotina: NavLogPlayer
   %Autores: Andr Luiz Carvalho Ottoni (UFRB) - andreottoni@ymail.com
   %         Erivelton Geraldo Nepomuceno (UFSJ)
   %         Marcos Santos de Oliveira (UFSJ)
   %Data de criao: 28/08/2018   
   %Descrio: Executa o LogPlayer do LARSim Nav

    %Comanda para gerar um vdeo da simulao
    %A = avifile('Animacao3.avi');

    %definices inciais
    n=length(caminhox); % nmero iteraes
    cont=1;
    pontox(1) = 0;
    pontoy(1) = 0;
    t = linspace(0,2*pi);

    %loop para gerar a parte grfica em cada instante de tempo
    for i=1:length(caminhox)
        %Armazena as posies nos instantes t e t+1
        xa = [ caminhox(i), caminhox(i+1) ];
        ya = [ caminhoy(i), caminhoy(i+1) ];
        % Primeiro subplot - imagem do ambiente e agente
        subplot(2,1,1)
        %Gera o ambiente com obstculos
       
        switch mapa
            case 1
                fill([0 0 15 15 0],[-16 0 0 -16 -16],'r',...
                    [2 2 14 14 2],[-15 -2 -2 -15 -15],[0.19    0.80    0.19],...
                    [3.5 3.5 4.5 4.5 3.5],[-16 -14.5 -14.5 -16 -16],[0.7    0.80    0.19],...
                    [6.5 6.5 9.5 9.5 6.5],[-8.5 -5.5 -5.5 -8.5 -8.5],'r',...
                    [2 2 2.5 2.5 2],[-8.5 -4.5 -4.5 -8.5 -8.5],'r',...
                    [3.5 3.5 4.5 4.5 3.5],[-12.5 -10.5 -10.5 -12.5 -12.5],'r',...
                    [7.5 7.5 9.5 9.5 7.5],[-11.5 -10.5 -10.5 -11.5 -11.5],'r',...
                    [11.5 11.5 13.5 13.5 11.5],[-10.5 -8.5 -8.5 -10.5 -10.5],'r',...
                    [8.5 8.5 10.5 10.5 8.5],[-2.5 -2 -2 -2.5 -2.5],'r',...
                    [13.5 13.5 14 14 13.5],[-6.5 -4.5 -4.5 -6.5 -6.5],'r',...
                    [6.5 6.5 7.5 7.5 6.5],[-3.5 -2.5 -2.5 -3.5 -3.5],'r',...
                    [10.5 10.5 11.5 11.5 10.5],[-5.5 -4.5 -4.5 -5.5 -5.5],'r',...
                    [9.5 9.5 10.5 10.5 9.5],[-8.5 -7.5 -7.5 -8.5 -8.5],'r',...
                    [2.5 2.5 3.5 3.5 2.5],[-8.5 -7.5 -7.5 -8.5 -8.5],'r');
        
           case 2
                
                fill([0 0 15 15 0],[-16 0 0 -16 -16],'r',...
                    [2 2 14 14 2],[-15 -2 -2 -15 -15],[0.19    0.80    0.19],...
                    [3.5 3.5 4.5 4.5 3.5],[-16 -14.5 -14.5 -16 -16],[0.7    0.80    0.19],...
                    [6.5 6.5 7.5 7.5 6.5],[-7.5 -3.5 -3.5 -7.5 -7.5],'r',...
                    [9.5 9.5 10.5 10.5 9.5],[-8.5 -3.5 -3.5 -8.5 -8.5],'r',...
                    [6.5 6.5 7.5 7.5 6.5],[-15 -12.5 -12.5 -15 -15],'r',...
                    [9.5 9.5 10.5 10.5 9.5],[-15 -11.5 -11.5 -15 -15],'r',...
                    [2 2 7.5 7.5 2],[-10.5 -9.5 -9.5 -10.5 -10.5],'r',...
                    [10.5 10.5 14 14 10.5],[-8.5 -7.5 -7.5 -8.5 -8.5],'r');
                
                        
           case 3
                    fill([0 0 15 15 0],[-16 0 0 -16 -16],'r',...
                    [2 2 14 14 2],[-15 -2 -2 -15 -15],[0.19    0.80    0.19],...
                    [3.5 3.5 4.5 4.5 3.5],[-16 -14.5 -14.5 -16 -16],[0.7    0.80    0.19],...
                    [2 2 11.5 11.5 2],[-3.5 -2.5 -2.5 -3.5 -3.5],'r',...
                    [2 2 11.5 11.5 2],[-11.5 -10.5 -10.5 -11.5 -11.5],'r',...
                    [4.5 4.5 14 14 4.5],[-7.5 -6.5 -6.5 -7.5 -7.5],'r');
        end
        
        hold on
        %gera a estrela amarela no objetivo
        plot(xa(2),-ya(2),13,-3,'y*');

        %gera o agente na cor azul
        fill(0.09*cos(t)+xa(2),0.5*sin(t)-ya(2),'b'); %cabea
        line(xa,-ya); %cauda


        axis([1.5 14.5 -16 -1])

        hold off

        axis on

        % Adione cada frame do vdeo
        F=getframe;
        %A = addframe(A,F);

        %Realiza a contagem do nmero de vezes que o o agente chega
        %no objetivo para alterar o grfico de sucessos acumulados

        if (caminhoy(i)==3) && (caminhox(i)==13)
            cont = cont+1;
            pontox(i) = i;
            pontoy(i) = cont-1;

        else

            pontox(i) = i;
            pontoy(i) = cont-1;
        end

        %Subplot 2: gera o grfico de sucessos acumulados
        subplot(2,1,2);
        plot(pontox,pontoy,'-o');
        ylabel('Sucessos Acumulados');
        xlabel('Iteraes');

    end

    %fecha o arquivo de vdeo
    %A=close(A);

end
