function [s2] = NavObservaEstado(M, Posy, Posx)
% function [s2] = NavObservaEstado(M, Posy, Posx) retorna o novo estado
%
% Entradas
%	M       - matriz de mapeamento
%	Posy	- posio do agente em y
%	Posx	- posio do agente em x
%
% Sada
%	s2    - novo estado 
%------------Universidade Federal do Recncavo da Bahia--------------
%-------------Universidade Federal de So Joo del-Rei---------------------
%---------------Grupo de Controle e Modelagem------------------------------
%Funo: NavObservaEstado()
%Autores: Andr Luiz Carvalho Ottoni (UFRB) - andreottoni@ymail.com
%         Erivelton Geraldo Nepomuceno (UFSJ)
%         Marcos Santos de Oliveira (UFSJ)
%Data de criao: 11/07/2016      
%Descrio: Observa o novo estado

  %Estados
  %1. Caminho Livre somente no Norte.
  %2. Caminho Livre somente no Oeste.
  %3. Caminho Livre somente no Leste.
  %4. Caminho Livre somente no Norte e Oeste.
  %5. Caminho Livre somente no Norte e Leste.
  %6. Caminho Livre somente no Oeste e Leste.
  %7. Caminho Livre no Norte, Oeste e Leste.
  %8. Objetivo no Norte. 
  %9. Objetivo no Oeste.
  %10. Objetivo no Leste. 
   
  % Realiza comparaes para verificar qual o novo estado
   
  if (M(Posy-1, Posx)==0) && (M(Posy, Posx-1) == 1) && (M(Posy, Posx+1)==1)
      s2=1;
  end
  
  if (M(Posy-1, Posx)==1) && (M(Posy, Posx-1) == 0) && (M(Posy, Posx+1)==1)
      s2=2;
  end
  
  if (M(Posy-1, Posx)==1) && (M(Posy, Posx-1) == 1) && (M(Posy, Posx+1)==0)
      s2=3;
  end
  
  if (M(Posy-1, Posx)==0) && (M(Posy, Posx-1) == 0) && (M(Posy, Posx+1)==1)
      s2=4;
  end
  
  if (M(Posy-1, Posx)==0) && (M(Posy, Posx-1) == 1) && (M(Posy, Posx+1)==0)
      s2=5;
  end
  
  if (M(Posy-1, Posx)==1) && (M(Posy, Posx-1) == 0) && (M(Posy, Posx+1)==0)
      s2=6;
  end
  
  if (M(Posy-1, Posx)==0) && (M(Posy, Posx-1) == 0) && (M(Posy, Posx+1)==0)
      s2=7;
  end
  
  if M(Posy-1, Posx)==2
      s2=8;
  end
  
  if M(Posy, Posx-1)==2
      s2=9;
  end
  
  if M(Posy, Posx+1)==2
      s2=10;
  end 
end