% Rotina SimuladorLabirinto para executar o LARSim Nav
%------------Universidade Federal do Recncavo da Bahia--------------
%-------------Universidade Federal de So Joo del-Rei---------------------
%---------------Grupo de Controle e Modelagem------------------------------
%Funo: SimuladorLabirinto
%Autores: Andr Luiz Carvalho Ottoni (UFRB) - andreottoni@ymail.com
%         Erivelton Geraldo Nepomuceno (UFSJ)
%         Marcos Santos de Oliveira (UFSJ)
%Data de criao: 11/07/2016      
%Descrio: Executa o simulador do labirinto - cdigo principal
function [caminhox,caminhoy,passos,resultado,episodio,chegou]=NavSimuladorLabirinto(nav,taxa,fator,e,alg,m) 

%clc; clear all; close all;
%%%%%%%%%%%%

%nav = 2; 
if nav == 1
    num_s = 10;
else
    num_s = 225;
end

localizacao =1;
Mapa_local = zeros (15,15);
for i=1:15
    for j=1:15
        Mapa_local(i, j) = localizacao;
        localizacao = localizacao + 1;
    end
end

switch m 
    case 1
       %Matriz de mapeamento (1 - Obstculo, 0 - Caminho Livre, 2 - Ponto Final)
      [M,M_L,Posinicialy,Posinicialx,Posfinaly,Posfinalx] = NavMapa();
    case 2
       %Matriz de mapeamento (1 - Obstculo, 0 - Caminho Livre, 2 - Ponto Final)
      [M,M_L,Posinicialy,Posinicialx,Posfinaly,Posfinalx] = NavMapa2();
    case 3
       %Matriz de mapeamento (1 - Obstculo, 0 - Caminho Livre, 2 - Ponto Final)
      [M,M_L,Posinicialy,Posinicialx,Posfinaly,Posfinalx] = NavMapa3();
end
 
Posy = Posinicialy;
Posx = Posinicialx;

Posicaox(1) = Posx;
Posicaoy(1) = Posy;

%Definies Iniciais do AR
visitas = zeros(num_s,3);
R = NavReforcoReativo();
alfa = taxa;
gamma = fator;

resultado_geral = zeros(64*10^3,3); 
cont_arq = 0; % Faz a contagem do nmero do arquivo  
      

%Inicializando as Matrizes Q1 
Q1 = zeros(num_s,3);

%Iniacilizando parmetros do algoritmo
ite = 10000; %quantidade de iteraes
chegou = 0; %armazena a quantidade de vezes o agente chegou ao objetivo
episodio = 0; %armazena a quantidade de episodios
max_episodios = 1000; %numero maximo de episodios
qtd_passos = 0; %quantidade de passos para chegar ao objetivo
qtd_pas = 0;

chegou_ite = zeros(ite,1);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

s = 1; %livre somente pro norte
cont = 0;
s_L = Mapa_local(Posy, Posx);

%Selecione a Ao
if nav == 1
    [a] = NavSelecionaAcao(Q1, s, num_s, e);
else
    [a] = NavSelecionaAcao(Q1, s_L, num_s, e);
end

while(episodio<max_episodios)
 
  %Executa a Ao
  [Posy, Posx, episodio, result] = NavExecutaAcao(a, Posy, Posx, episodio, Posinicialy, Posinicialx, M);
 
  if (result == 0)
      resultado(episodio) = result; % resultado(episodio) = 0 => bateu no obstculo
  end
  
  caminhox(cont+1) = Posx;
  caminhoy(cont+1) = Posy;

  %Atualizaes para no caso do agente chegar no objetivo
  if(Posx==Posfinalx)&&(Posy==Posfinaly) %Alcancou o objetivo => volta para a posicao inicial
       chegou = chegou +1;     
       episodio = episodio+1;
       passos(chegou) = qtd_passos - qtd_pas;
       qtd_pas = qtd_passos;
       Posy = Posinicialy;
       Posx = Posinicialx;
       resultado(episodio) = 1; % resultado(episodio) = 1 => chegou no objetivo
  end
  
  chegou_ite(cont+1) = chegou;
  
  %Observando o Novo Estado
  [s2] = NavObservaEstado(M, Posy, Posx);
  
  %Estado com Localizacao
  s2_L = Mapa_local(Posy, Posx);
  %Reforo com Localizacao
  R_L = M_L(Posy, Posx);
  
 if nav == 1
    ss = s2; 
 else
    ss = s2_L;
 end 
  
  %verifica qual a ao mais bem estimada para o novo estado
  maior1 = Q1(ss,a);
  for i=1:num_s
    for j = 1:3
        if(i == ss) %Se i igual ao novo estado s2
           if(Q1(i,j)>maior1)
               maior1 = Q1(i,j);
           end
        end
    end
  end
  
  %Selecione a Nova ao
  if nav == 1
      [aa] = NavSelecionaAcao(Q1, ss, num_s, e);
  else
      [aa] = NavSelecionaAcao(Q1, ss, num_s, e);
  end
  
 if nav == 1
    visitas(s,a) = visitas(s,a)+1; %conta o nmero de visitas em cada par estado x ao
    if alg == 1
        Q1(s,a) = Q1(s,a)+alfa*(R(s,a)+gamma*maior1-Q1(s,a)); %atualiza a matriz de aprendizado Q-learning
    else
        Q1(s,a) = Q1(s,a)+alfa*(R(s,a)+gamma*Q1(ss,aa)-Q1(s,a)); %atualiza a matriz de aprendizado SATSA
    end
 else
    visitas(s_L,a) = visitas(s_L,a)+1;
    if alg == 1
        Q1(s_L,a) = Q1(s_L,a)+alfa*(R(s,a)-R_L+gamma*maior1-Q1(s_L,a)); %atualiza a matriz de aprendizado Q-learning
    else
        Q1(s_L,a) = Q1(s_L,a)+alfa*(R(s,a)-R_L+gamma*Q1(ss,aa)-Q1(s_L,a)); %atualiza a matriz de aprendizado SATSA
    end
 end 
 
  s = s2;  %atualiza o estado corrente
  a = aa;
  s_L = s2_L;
  
  cont = cont+1; %atualiza o nmero de iteraes
  qtd_passos = qtd_passos+1; % atualiza o nmero de passos at chegar no objetico
  
  %Atualiza o vetores que armazenam as posies em x e y
  Posicaox(cont+1) = Posx; 
  Posicaoy(cont+1) = Posy;
   
end

%Plota os Grficos
%PlotFiguras(passos, episodio, resultado, chegou_ite);

end



