%------------Universidade Federal do Recncavo da Bahia--------------
%-------------Universidade Federal de So Joo del-Rei---------------------
%---------------Grupo de Controle e Modelagem------------------------------
%Funo: TSPSimuladorPCV()
%Autores: Andr Luiz Carvalho Ottoni (UFRB) - andreottoni@ymail.com
%         Erivelton Geraldo Nepomuceno (UFSJ)
%         Marcos Santos de Oliveira (UFSJ)
%Data de criao: 28/08/2018  
%Descrio: Cdigo principal do Simulao do Problema do Caixeiro Viajante
function [menor,distancia,episodio,visita,N,posicao,otimo,nome] = TSPSimuladorPCV_e(alpha,gamma,e,alg,num_episodios,inst,tip_e)
switch inst
    case 1
        [Dist,posicao,N,otimo,nome] = TSPberlin52();
    case 2
        [Dist,posicao,N,otimo,nome] = TSPch130();
    case 3
        [Dist,posicao,N,otimo,nome] = TSPeil101();
    case 4
        [Dist,posicao,N,otimo,nome] = TSPkroA100();
    case 5
        [Dist,posicao,N,otimo,nome] = TSPkroA150();
    case 6
        [Dist,posicao,N,otimo,nome] = TSPkroA200();   
    case 7
        [Dist,posicao,N,otimo,nome] = TSPlin105(); 
    case 8
        [Dist,posicao,N,otimo,nome] = TSPpr124(); 
    case 9
        [Dist,posicao,N,otimo,nome] = TSPrat195(); 
    case 10
        [Dist,posicao,N,otimo,nome] = TSPrd400(); 
end

D = Dist;
%--------------------------------------------------------------------------

Q=0*ones(N);R=-D;              %matriz Q (estado-ao) e R (recompensa)
n_visitas = zeros(N);          %armazena o nmero de visitas em cada S,A

%Estado Inicial e Ao incial
So=1; Ao=17;
S=So; A=Ao;        %(estado,ao) par inicial
cont=1;
while cont<(num_episodios+1)  %1000  nmero de episdios - loop de episdios
    distancia(cont)=0;           %distncia total do caminho percorrido
    bag=1:N;                       %informa quais cidades j foram escolhidas
    bag(So)=0;
    for i=1:N                    %loop que garante a visita a todas cidades em um episdio
        bag(A)=0;
        [resto]=find(bag~=0); % a varivel resto armazena as cidades que ainda no foram visitas
        
        %retorno  origem (So) se no existem mais cidades para visitar
        if isempty(resto), resto=[So]; end
        
        %e = 1/(1+n_visitas(S,A));
        if tip_e == 1
           e = 1/(1+cont);
          % e = 1/(1+cont);
          % e = 1/(1+cont);
        end
        
        %Atualiza a matriz de aprendizado com a funo Q-learning. Na
        %funo tambm tem a atualizao pelo SARSA
        if alg == 1
            [SS,AA,Q]=Qlearning(S,A,R(S,A),Q,alpha,e,gamma,resto); %function [SS,AA,Q]=Q_Learning(S,A,R,Q)
        else
            [SS,AA,Q]=SARSA(S,A,R(S,A),Q,alpha,e,gamma,resto); %function [SS,AA,Q]=Q_Learning(S,A,R,Q)
        end
        S=SS; A=AA; %st = st+1 e at = at+1
            
        distancia(cont)=distancia(cont)+D(S,A);  %distncia total do caminho percorrido 
            
        visita(cont,i,:)=[S A]; %armazena a vista ao par S,A  
        n_visitas(S,A) = n_visitas(S,A)+1; %contador de nmero de visitas ao par S,A
    end
    if alg == 1
        [SS,AA,Q]=Qlearning(S,A,R(S,A),Q,alpha,e,gamma,resto); %function [SS,AA,Q]=Q_Learning(S,A,R,Q)
    else
        [SS,AA,Q]=SARSA(S,A,R(S,A),Q,alpha,e,gamma,resto); %function [SS,AA,Q]=Q_Learning(S,A,R,Q)
    end
    cont=cont+1; %incrementa o contador de episdios
end

%Menor rota
menor = min(distancia);
%Episdio com a menor rota
episodio = find(distancia==min(distancia)); 

%Grficos 

%Distncia calculada ao longo do tempo
%figure(1);
%plot(distancia);

%Rota gerada
%desenharrota(episodio,visita,N);
end
